
if ~exist('calib_name')|~exist('format_image'),
   data_calib_no_read;
   return;
end;

check_directory;

if ~exist('n_ima'),
   data_calib_no_read;
   return;
end;

check_active_images;


images_read = active_images;


if exist('image_numbers'),
   first_num = image_numbers(1);
end;


% Just to fix a minor bug:
if ~exist('first_num'),
   first_num = image_numbers(1);
end;


image_numbers = first_num:n_ima-1+first_num;


no_image_file = 0;

%% Step used to clean the memory if a previous atttempt has been made to read the entire set of images into memory:
for kk = 1:n_ima,
    if (exist(['I_' num2str(kk)])==1),
        clear(['I_' num2str(kk)]);
    end;
end;


fprintf(1,'\nChecking directory content for the calibration images (no global image loading in memory efficient mode)\n');



i = 1;

while (i <= n_ima), % & (~no_image_file),
    
    if active_images(i),
        
        %fprintf(1,'Loading image %d...\n',i);
        
        if ~type_numbering,   
            number_ext =  num2str(image_numbers(i));
        else
            number_ext = sprintf(['%.' num2str(N_slots) 'd'],image_numbers(i));
        end;
        
        ima_name = [calib_name  number_ext '.' format_image];
        
        if i == ind_active(1),
            fprintf(1,'Found images: ');
        end;
        
        if exist(ima_name),
            
            fprintf(1,'%d...',i);
            
        else
            
            images_read(i) = 0;
            
        end;
        
    end;
    
    i = i+1;   
    
end;


ind_read = find(images_read);


if ~(exist('map')==1), map = gray(256); end;

active_images = images_read;

fprintf(1,'\ndone\n');
