% Anisotropically diffuse the calibration image
% to enhance the corner detection


fprintf(1,'Anisotropic diffusion of the images for corner enhancement (the images have to be loaded in memory)\n');



if ~exist(['I_' num2str(ind_active(1))]),
   ima_read_calib;
end;

check_active_images;   

format_image2 = format_image;
if format_image2(1) == 'j',
   format_image2 = 'bmp';
end;

for kk = 1:n_ima,
   
   if exist(['I_' num2str(kk)]),
      
      %fprintf(1,'%d...',kk);
      
      eval(['I2 = anisdiff(I_' num2str(kk) ');']);
      
   	if ~type_numbering,   
      	number_ext =  num2str(image_numbers(kk));
   	else
      	number_ext = sprintf(['%.' num2str(N_slots) 'd'],image_numbers(kk));
   	end;
   	
      ima_name2 = [calib_name '_smth' number_ext '.' format_image2];
      
      fprintf(1,['Saving smoothed image under ' ima_name2 '...\n']);

      if format_image2(1) == 'p',
         if format_images2(2) == 'p',
            saveppm(ima_name2,uint8(round(I2)));
         else
            savepgm(ima_name2,uint8(round(I2)));
         end;
      else
         if format_image2(1) == 'r',
            writeras(ima_name2,round(I2),gray(256));
         else
            imwrite(uint8(round(I2)),gray(256),ima_name2,format_image2);
         end;
      end;
      
   end;
   
end;

fprintf(1,'\ndone\n');